/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};


const updateBitfield = async () => {
    const deviceObj = await registerModel.getRegisterViewInformation();                            		/* get the register view info 	*/
    const [regBlock] = deviceObj.regblocks.filter(regblock => regblock.name === 'CONFIGURATION');	    /* compare by name or id 	    */
    if (regBlock) {   
        const [reg] = regBlock.registers.filter(reg => reg.name === 'CONFIG_REG');    		            /* compare by name or id    	*/  
        if (reg) {        
            const [bitfield] = reg.fields.filter(bitfield => bitfield.name === 'CONV_MODE');        	/* compare by name or id	    */        
            if (bitfield) {            
                switch(templateObj.$.ti_widget_droplist.selectedIndex) {
                    case 0:
                        bitfield.options = [{ display: 'To Infinity and Beyond #1', value: 1 }];
                        break;
                    case 1:
                        bitfield.options = [{ display: 'To Infinity and Beyond #2', value: 2 }];
                        break;
                }
                /* workaround the bitfield is not refreshed */
                const tmp = document.querySelector('#ti_widget_register_page').selectedRegister;
                document.querySelector('#ti_widget_register_page').selectedRegister = undefined;
                document.querySelector('#ti_widget_register_page').selectedRegister = tmp;
            }    
        }
    }
};

var initComplete = false;
var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId


            templateObj.$.ti_model_register.addEventListener('registerDefsChanged', () => { 
                updateBitfield(); 
            });
            
            templateObj.$.ti_widget_droplist.addEventListener('selected-index-changed', () => {
                updateBitfield();
            });
        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}


